#
# TODO mettre les mots en minuscule pour indexation
#
#
# Simple HTML display library by Stephen Uhler (stephen.uhler@sun.com)
############################################
# mapping of html tags to text tag properties
# properties beginning with "T" map directly to text tags

proc HMtest_parse {command tag slash text_after_tag} {
global titlehtml

 set text [ string trim [ string tolower $command ] ]
	if { $text=="title" } {
#		puts stderr "$text_after_tag"
		regsub -all "\n" $text_after_tag {} text_after_tag		
		set titlehtml $titlehtml$text_after_tag
		}
}

proc HMparse_html {html {cmd HMtest_parse}} {
	regsub -all \{ $html {\&ob;} html
	regsub -all \} $html {\&cb;} html
	set w " \t\r\n"	;# white space
	proc HMcl x {return "\[$x\]"}
	set exp <(/?)([HMcl ^$w>]+)[HMcl $w]*([HMcl ^>]*)>
	set sub "\}\n$cmd {\\2} {\\1} {\\3} \{"
	regsub -all $exp $html $sub html
	eval "$cmd hmstart {} {} \{ $html \}"
}

proc indexonefile { fp indexfile} {
global  INDEXARRAY
# set DICO(toto) 0
 while {![eof $fp]} {
	set ligne [gets $fp] 
#
# On enleve les tag htmls
#TODO il faut concerver les titres
# TODO :
#aacute          
#auml   
#aelig           
set translatehtmlcar { {nbsp "" } \
			{eacute }\
			{egrave }\
			{lt ""}\
			{gt ""}\
			{amp ""}\
			{quot ""}\
			{agrave }\
			{acirc  }\
			{atilde }\
			{ccedil  }\
			{ecirc  }\
			{icirc  }\
			{ntilde  }\
			{ocirc  }\
			{otilde }\
			{ugrave }\
			{ucirc  } }

	regsub -all {<([^<])*>} $ligne {} ligne
	foreach assotagcar $translatehtmlcar {
		set rexp "&[lindex $assotagcar 0];" 
		regsub -all $rexp  $ligne "[lindex $assotagcar 1]" ligne
	}

	foreach  { -- num  } [regexp -all  -inline {(\w+)} $ligne ] {
		set num [ string tolower $num ]
		if {[info exists DICO($num)]} {
			incr DICO($num)
		} else {
			set DICO($num) "1"
		}
	}
 }
foreach a [array names DICO ] {
	if {[info exists INDEXARRAY($a)]} {
			set INDEXARRAY($a)  $INDEXARRAY($a):$indexfile,$DICO($a)
		} else {
			set INDEXARRAY($a) "$indexfile,$DICO($a)"
		}
    }
}

proc glob-r {{dir .}} {

set res {} 
foreach i [lsort [glob -nocomplain $dir/* ]] {
	 if {[file type $i]=="directory"} { 
	eval lappend res [glob-r $i]
	 } else { 
	if ([ regexp {[a-z\:\\\/.]+html} $i toto ]) {
		lappend res $i
		}
	 }
    } 
return $res
} 

#	foreach  { -- num  } [regexp -all  -inline {([a-zA-Z][A-Za-z0-9]+)} $ligne ] {
#
#
#
proc startindexing { sock } {
global titlehtml 
global INDEXARRAY 

set ouputfile [open "result.txt" w]
set nbfile 0

puts stderr " starindexing "

puts $sock "<html><head><title> Indexing </title><head><h1> Indexing </h1> "
flush $sock

set listfile [ glob-r .]
foreach file $listfile {
	incr nbfile 
	puts stderr "processing $file **** "
	
	#
	# Delete the 2 caracteres of the path should be ./
	#
	set filename [ string range $file 2 [string length $file ] ]
	set filewithtitle($filename) $filename 


	puts $sock "processing $filename <br> "
	flush $sock

	set fp [open $filename]
	indexonefile $fp $nbfile 
	
	close $fp
}

puts $ouputfile "\[files:$nbfile\]"
set nbfile 0
foreach file $listfile {

	incr nbfile 
#
# Find the html title, title by default is the filename
#
	set titlehtml ""
	set fp [ open $file r]
	catch {HMparse_html [ read $fp ] }
	close $fp
	if {$titlehtml == "" } {
		set filename $file
		}
#
# Save the number filename and title
#
	puts $ouputfile "$nbfile#$file#$titlehtml"
	}

puts $sock "<br>save indexed words.... </h1><br>"
flush $sock
#
# save indexing words
#
puts $ouputfile "\[words:[array size INDEXARRAY ]\]"
foreach a [lsort [array names INDEXARRAY ] ] {
	puts $ouputfile "$a=>$INDEXARRAY($a)"
	}

close $ouputfile 

puts stderr "Indexing finished .... <br>"
puts $sock "<br><h1>Indexing finished .... </h1><br>"
puts $sock " <form action=\"searchcgi.cgi\" method=\"get\"> <input name=\"name\" size=\"40\"> <input type=\"submit\">  </form> "

puts $sock "<br><h2><a href=\"frame.html\"> Return index <a/></h2><br>"
flush $sock
indexing 
}
# set fp [open $filename] 
#while {-1 != [gets $fp line]} { puts $line } 
#puts "*This* coding does what readers expect." 
#	foreach  { -- num  } [regexp -all -inline {([a-z][a-z0-9]+)} $ligne ] {
#	foreach  { -- num  } [regexp -all -inline {[[:alpha:]]+} $ligne ] {

#
# Creation d'un fichier d'indexation sur la base d'indexation
#
proc indexing { } {

set findexing [open "indexing.txt" w ]

#
# Passe les nom de fichiers et titres
#
set f [open "./result.txt" r ]
set nbfile [ gets $f ]
regsub {\[} $nbfile "set  " nbfile
regsub {\]} $nbfile " " nbfile
regsub "\:" $nbfile " " nbfile
eval $nbfile

for { set i 0 } { $i < $files } { incr i } {
	 gets $f 
}

#
# Lecture du nombre de mots
#
set nbword [ gets $f ]
regsub {\[} $nbword "set  " nbword
regsub {\]} $nbword " " nbword
regsub "\:" $nbword " " nbword
eval $nbword
set i 0
#
# Attention ceci doit poser des problemes avec l'unicode et lettre accentu
#
while { $i < $words } {
set posfile [ tell $f ]
set wordline [ gets $f ]
incr i
set twolettre [string range $wordline 0 1 ]
if {![ info exist posinindexfile($twolettre) ]} {
	set posinindexfile($twolettre) $posfile 
	}
}

foreach a [array names posinindexfile ] {
	puts $findexing "$a $posinindexfile($a)"
	}
close $findexing
}

